import * as i0 from '@angular/core';
import { Injectable, Component, Inject, EventEmitter, Output, Pipe, Input, ViewChild, NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { MatSidenavModule } from '@angular/material/sidenav';
import { MatIconModule } from '@angular/material/icon';
import { MatFormFieldModule } from '@angular/material/form-field';
import { MatInputModule } from '@angular/material/input';
import { MatListModule } from '@angular/material/list';
import { MatSelectModule } from '@angular/material/select';
import { MatAutocompleteModule } from '@angular/material/autocomplete';
import { MatDatepickerModule } from '@angular/material/datepicker';
import { MatCheckboxModule } from '@angular/material/checkbox';
import { MatStepperModule } from '@angular/material/stepper';
import { MatTooltipModule } from '@angular/material/tooltip';
import { MatTreeModule } from '@angular/material/tree';
import { MatButtonModule } from '@angular/material/button';
import { MatExpansionModule } from '@angular/material/expansion';
import { MatGridListModule } from '@angular/material/grid-list';
import { MatRadioModule } from '@angular/material/radio';
import { DateAdapter, MAT_DATE_LOCALE, MAT_DATE_FORMATS } from '@angular/material/core';
import { MatCardModule } from '@angular/material/card';
import * as i1$1 from '@angular/common/http';
import { HttpClient, HttpClientModule, HttpHeaders } from '@angular/common/http';
import * as i1$2 from '@angular/forms';
import { FormGroup, FormControl, Validators, FormBuilder, ReactiveFormsModule } from '@angular/forms';
import { BehaviorSubject, timer, ReplaySubject, forkJoin, throwError } from 'rxjs';
import { transform, isEqual, isObject, merge } from 'lodash';
import * as i1 from '@angular/material/dialog';
import { MAT_DIALOG_DATA, MatDialogRef, MatDialog, MatDialogModule } from '@angular/material/dialog';
import * as moment from 'moment';
import { startWith, map, tap } from 'rxjs/operators';
import { MAT_MOMENT_DATE_FORMATS, MatMomentDateModule, MomentDateAdapter } from '@angular/material-moment-adapter';
import { registerLocaleData, CommonModule } from '@angular/common';
import localeDe from '@angular/common/locales/de';
import { SelectionModel } from '@angular/cdk/collections';
import { MatTableDataSource, MatTableModule } from '@angular/material/table';
import { MatSort, MatSortModule } from '@angular/material/sort';
import { MatPaginator, MatPaginatorModule } from '@angular/material/paginator';
import { MatSliderModule } from '@angular/material/slider';
import { MatSlideToggleModule } from '@angular/material/slide-toggle';
import * as i1$3 from '@angular/router';
import { Router } from '@angular/router';

class FormbuilderService {
    constructor() { }
}
FormbuilderService.ɵprov = i0.ɵɵdefineInjectable({ factory: function FormbuilderService_Factory() { return new FormbuilderService(); }, token: FormbuilderService, providedIn: "root" });
FormbuilderService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
FormbuilderService.ctorParameters = () => [];

class FormbuilderComponent {
    constructor() { }
    ngOnInit() {
    }
}
FormbuilderComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-formbuilder',
                template: `
    <p>
      formbuilder works!
    </p>
  `
            },] }
];
FormbuilderComponent.ctorParameters = () => [];

class ConfirmDialogComponent {
    constructor(data, dialogRef) {
        this.data = data;
        this.dialogRef = dialogRef;
        this.icon = 'questionmark';
        this.errorMsg = [];
    }
    ngOnInit() {
        if (!this.data) {
            return;
        }
        this.dialogRef.disableClose = true;
        if (!!this.data.icon) {
            this.icon = this.data.icon;
        }
        if (!!this.data.message) {
            this.message = this.data.message;
        }
        else {
            this.message = 'Sind Sie sicher?';
        }
        console.log(this.message);
    }
}
ConfirmDialogComponent.decorators = [
    { type: Component, args: [{
                selector: 'app-confirm-dialog',
                template: "<div id=\"confirm-dialog_title\">\n  <mat-icon class=\"md-48\">{{icon}}</mat-icon>\n  <h2>Sind Sie sicher?</h2>\n</div>\n\n<mat-dialog-content id=\"confirm-dialog_content\">\n\n  <p id=\"confirm-dialog_message\">{{message | translate}}</p>\n\n</mat-dialog-content>\n\n<mat-dialog-actions class=\"flex-center\">\n  <button id=\"error-dialog_button-no\" class=\"button-big secondary\" mat-raised-button [mat-dialog-close]=\"false\">Nein\n  </button>\n  <div class=\"space-width-20\"></div>\n  <button id=\"error-dialog_button-yes\" class=\"button-big\" mat-raised-button [mat-dialog-close]=\"true\" color=\"primary\">\n    Ja\n  </button>\n</mat-dialog-actions>\n",
                styles: ["#confirm-dialog_title{display:flex;justify-content:flex-start;align-items:center;padding:30px 60px 0}#confirm-dialog_title>h2{margin:0}#confirm-dialog_message{font-size:14px}mat-dialog-content#confirm-dialog_content{padding-left:60px!important;padding-right:60px!important}mat-icon{margin-right:20px}\n"]
            },] }
];
ConfirmDialogComponent.ctorParameters = () => [
    { type: undefined, decorators: [{ type: Inject, args: [MAT_DIALOG_DATA,] }] },
    { type: MatDialogRef }
];

class ErrorDialogSimpleComponent {
    constructor(data, dialogRef) {
        this.data = data;
        this.dialogRef = dialogRef;
        this.icon = 'error';
        this.errorMsg = [];
    }
    ngOnInit() {
        if (!this.data) {
            return;
        }
        this.dialogRef.disableClose = true;
        if (!!this.data.icon) {
            this.icon = this.data.icon;
        }
        if (!!this.data.errorMsg && Array.isArray(this.data.errorMsg)) {
            this.errorMsg = this.data.errorMsg;
        }
        else {
            this.errorMsg = [String(this.data.errorMsg)];
        }
    }
}
ErrorDialogSimpleComponent.decorators = [
    { type: Component, args: [{
                selector: 'app-error-dialog-simple',
                template: "<div id=\"error-dialog_title\">\n  <mat-icon class=\"md-48 hipps-error-icon\">{{icon}}</mat-icon>\n  <h2 *ngIf=\"errorMsg.length < 2\">Es ist ein Fehler aufgetreten!</h2>\n  <h2 *ngIf=\"errorMsg.length > 1\">Es sind Fehler aufgetreten!</h2>\n</div>\n\n<mat-dialog-content id=\"error-dialog_content\">\n\n  <mat-list id=\"error-dialog_error-list\">\n    <mat-list-item class=\"error-dialog_message\" *ngFor=\"let msg of errorMsg\">{{errorMsg | translate}}</mat-list-item>\n  </mat-list>\n\n</mat-dialog-content>\n\n<mat-dialog-actions class=\"flex-center\">\n  <button id=\"error-dialog_button-ok\" class=\"button-big\" mat-raised-button cdkFocusInitial [mat-dialog-close]=\"true\"\n          color=\"primary\">\n    OK\n  </button>\n</mat-dialog-actions>\n",
                styles: ["#error-dialog_title{display:flex;justify-content:flex-start;align-items:center;padding:30px 60px 0}#error-dialog_title>h2{margin:0}mat-list-item.error-dialog_message{font-size:14px;word-break:break-all}mat-dialog-content#error-dialog_content{padding-left:60px!important;padding-right:60px!important}mat-icon{margin-right:20px}\n"]
            },] }
];
ErrorDialogSimpleComponent.ctorParameters = () => [
    { type: undefined, decorators: [{ type: Inject, args: [MAT_DIALOG_DATA,] }] },
    { type: MatDialogRef }
];

class InfoDialogSimpleComponent {
    constructor(data, dialogRef) {
        this.data = data;
        this.dialogRef = dialogRef;
        this.icon = 'info';
        this.infoMsg = [];
    }
    ngOnInit() {
        if (!this.data) {
            return;
        }
        this.dialogRef.disableClose = true;
        if (!!this.data.icon) {
            this.icon = this.data.icon;
        }
        if (!!this.data.infoMsg && Array.isArray(this.data.infoMsg)) {
            this.infoMsg = this.data.infoMsg;
        }
        else {
            this.infoMsg = [String(this.data.infoMsg)];
        }
    }
}
InfoDialogSimpleComponent.decorators = [
    { type: Component, args: [{
                selector: 'app-info-dialog-simple',
                template: "<div id=\"info-dialog_title\">\n  <mat-icon class=\"md-48 hipps-warning-icon\">{{icon}}</mat-icon>\n  <h2>Information</h2>\n</div>\n\n<mat-dialog-content id=\"info-dialog_content\">\n\n  <mat-list id=\"info-dialog_info-list\">\n    <mat-list-item *ngFor=\"let msg of infoMsg\"\n                   class=\"info-dialog_message\">\n                   {{infoMsg | translate}}\n    </mat-list-item>\n  </mat-list>\n\n</mat-dialog-content>\n\n<mat-dialog-actions class=\"flex-center\">\n  <button id=\"info-dialog_button-ok\" class=\"button-big\" mat-raised-button cdkFocusInitial [mat-dialog-close]=\"true\"\n          color=\"primary\">OK</button>\n</mat-dialog-actions>\n",
                styles: ["#info-dialog_title{display:flex;justify-content:flex-start;align-items:center;padding:30px 60px 0}#info-dialog_title>h2{margin:0}mat-list-item.info-dialog_message{font-size:14px;height:20px;padding:0;word-break:break-all}mat-dialog-content#info-dialog_content{padding-left:50px!important;padding-right:50px!important}mat-icon{margin-right:20px}\n"]
            },] }
];
InfoDialogSimpleComponent.ctorParameters = () => [
    { type: undefined, decorators: [{ type: Inject, args: [MAT_DIALOG_DATA,] }] },
    { type: MatDialogRef }
];

class DialogService {
    constructor(dialog) {
        this.dialog = dialog;
    }
    showDataImportErrorDialog(errorDataArray, afterDialogCallback) {
        const dialogData = {
            dataImportErrors: errorDataArray
        };
        const dialogRef = this.dialog.open(MatDialog, {
            data: dialogData
        });
        dialogRef.afterClosed().subscribe((result) => {
            afterDialogCallback(result);
        });
        return dialogRef;
    }
    showErrorDialog(errorMsg, afterDialogCallback) {
        const dialogData = {
            errorMsg: errorMsg
        };
        const dialogRef = this.dialog.open(ErrorDialogSimpleComponent, {
            data: dialogData
        });
        dialogRef.afterClosed().subscribe((result) => {
            if (!!afterDialogCallback) {
                afterDialogCallback(result);
            }
        });
        return dialogRef;
    }
    showInfoDialog(infoMsg, afterDialogCallback) {
        const dialogData = {
            infoMsg: infoMsg
        };
        const dialogRef = this.dialog.open(InfoDialogSimpleComponent, {
            data: dialogData,
        });
        dialogRef.afterClosed().subscribe((result) => {
            if (!!afterDialogCallback) {
                afterDialogCallback(result);
            }
        });
        return dialogRef;
    }
    /**
     * messageString may also be an html String like:
     * <b>Are you sure?</b>
     *
     * @param {string} messageString
     * @param {Function} positiveCallback
     * @param {Function} negativeCallback
     */
    confirm(messageString, positiveCallback, negativeCallback) {
        console.log(messageString);
        const dialogData = {
            message: messageString
        };
        const dialogRef = this.dialog.open(ConfirmDialogComponent, {
            data: dialogData
        });
        dialogRef.afterClosed().subscribe((result) => {
            if (result === true) {
                positiveCallback();
            }
            else {
                if (!!negativeCallback) {
                    negativeCallback();
                }
            }
        });
    }
    xmlExport(positiveCallback, negativeCallback) {
        const dialogRef = this.dialog.open(MatDialog);
        dialogRef.afterClosed().subscribe((result) => {
            if (result) {
                positiveCallback(result);
            }
            else {
                if (!!negativeCallback) {
                    negativeCallback();
                }
            }
        });
    }
    setValid(positiveCallback, negativeCallback) {
        const dialogRef = this.dialog.open(MatDialog, { width: '350px' });
        dialogRef.afterClosed().subscribe((result) => {
            if (result) {
                positiveCallback(result);
            }
            else {
                if (!!negativeCallback) {
                    negativeCallback();
                }
            }
        });
    }
}
DialogService.ɵprov = i0.ɵɵdefineInjectable({ factory: function DialogService_Factory() { return new DialogService(i0.ɵɵinject(i1.MatDialog)); }, token: DialogService, providedIn: "root" });
DialogService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
DialogService.ctorParameters = () => [
    { type: MatDialog }
];

class TranslationService {
    constructor(http) {
        this.http = http;
        // tslint:disable-next-line: no-output-on-prefix
        this.onLangChange = new EventEmitter();
        // tslint:disable-next-line: no-output-on-prefix
        this.onDataChange = new EventEmitter();
        this.data = {};
        this.lang = 'de';
        this.userData = {};
        this._path = '';
        this.onLangChange.subscribe(val => {
            this.lang = val;
        });
    }
    setPath(path) {
        this._path = path;
    }
    addTxtFile(path) {
        return new Promise((resolve, reject) => {
            const langPath = `${path}${this.lang || 'de'}.json`;
            // console.log(langPath);
            this.http.get(langPath).subscribe(translation => {
                // console.log(translation);
                this.updateData(translation);
                this.onDataChange.emit(this.data);
                resolve(this.data);
            }, error => {
                resolve(this.data);
            });
        });
    }
    getUserData() {
        let txtFile = {};
        for (const key in this.userData) {
            if (this.userData) {
                Object.assign(txtFile, {
                    [key]: this.data[key]
                });
            }
        }
        return txtFile;
    }
    setLang(lang) {
        this.lang = lang;
        this.use(this.lang);
        this.onLangChange.emit(this.lang);
    }
    updateData(data) {
        Object.assign(this.data, data);
        this.onDataChange.emit(this.data);
    }
    use(lang) {
        return new Promise((resolve, reject) => {
            const langPath = `${this._path}${lang || 'de'}.json`;
            // console.log(langPath);
            this.http.get(langPath).subscribe(translation => {
                // console.log(translation);
                this.data = Object.assign({}, translation || {});
                this.lang = lang;
                this.onDataChange.emit(this.data);
                resolve(this.data);
            }, error => {
                this.data = {};
                resolve(this.data);
            });
        });
    }
    deleteKeys(data) {
        // this.data.
        let newdata = {};
        for (let [key, value] of Object.entries(this.data)) {
            console.log(key + ':' + value);
            let found = false;
            for (let [key2, value2] of Object.entries(data)) {
                if (key !== key2) {
                    found = true;
                }
                // console.log(key + ':' + value);
            }
            if (!found) {
                Object.assign(newdata, { [key]: value });
            }
        }
        this.data = newdata;
    }
    getFBData() {
        let txtFile = {};
        for (const key in this.data) {
            if (!this.userData[key]) {
                Object.assign(txtFile, {
                    [key]: this.data[key]
                });
            }
        }
        return txtFile;
    }
}
TranslationService.ɵprov = i0.ɵɵdefineInjectable({ factory: function TranslationService_Factory() { return new TranslationService(i0.ɵɵinject(i1$1.HttpClient)); }, token: TranslationService, providedIn: "root" });
TranslationService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
TranslationService.ctorParameters = () => [
    { type: HttpClient }
];
TranslationService.propDecorators = {
    onLangChange: [{ type: Output }],
    onDataChange: [{ type: Output }]
};

class TranslatePipe {
    constructor(translate) {
        this.translate = translate;
    }
    transform(key) {
        // console.log(key);
        if (key !== 'undefined') {
            // console.log(this.translate.data);
            return this.translate.data[key] || '';
        }
    }
}
TranslatePipe.decorators = [
    { type: Pipe, args: [{
                name: 'translate',
                pure: false
            },] }
];
TranslatePipe.ctorParameters = () => [
    { type: TranslationService }
];

function difference(newObj, origObj) {
    let arrayIndexCounter = 0;
    return transform(newObj, (result, value, key) => {
        if (!isEqual(value, origObj[key])) {
            let resultKey = typeof (origObj === 'array') ? arrayIndexCounter++ : key;
            result[resultKey] =
                isObject(value) && isObject(origObj[key])
                    ? difference(value, origObj[key])
                    : value;
        }
    });
}
class FormService {
    constructor(fb, ds, tp) {
        this.fb = fb;
        this.ds = ds;
        this.tp = tp;
        this.forms = new FormGroup({});
        this.configChange = new BehaviorSubject([]);
        this.fieldchange = new BehaviorSubject([]);
        this.fields = [];
        this.emptyObj = {
            name: 'home_ui_new'
        };
        this.fieldchange.subscribe(val => {
            this.fields.push(val);
        });
        this.configChange.subscribe((newVal) => {
            // this.setUp(newVal);
        });
    }
    getFields() {
        return this.fields;
    }
    getFieldByName(name) {
        return this.fields.find(field => field.name === name);
    }
    addField(val) {
        this.fieldchange.next(val);
    }
    /**
     * @param form : FormGroup
     * @param name : FormName
     * @description adds form to Service of creates one
     */
    addForm(form, pageName) {
        if (this.forms !== undefined && this.forms !== null) {
            if (this.forms.get(pageName)) {
                let tmpForm = this.forms.get(pageName);
                Object.assign(tmpForm, form);
                this.forms.removeControl(pageName);
                this.forms.addControl(pageName, tmpForm);
            }
            else {
                this.forms.addControl(pageName, form);
            }
        }
        else {
            this.forms = this.fb.group({ [pageName]: form });
        }
    }
    /**
     * @param config : { [ <PageName>: { <FormName>: { <FieldName>: IField } } ] }
     * @description adds Config to Service
     */
    addConfig(config) {
        if (this.configs !== undefined && this.configs !== null) {
            for (const [pageName, page] of Object.entries(config)) {
                for (const [formName, form] of Object.entries(page)) {
                    let controls = {};
                    for (const [fieldName, field] of Object.entries(form)) {
                        controls[fieldName] = field;
                    }
                    if (this.configs[pageName][formName]) {
                        Object.assign(this.configs[pageName][formName], controls);
                    }
                    else {
                        this.configs[pageName][formName] = controls;
                    }
                }
            }
        }
        else {
            this.configs = config;
        }
        this.configChange.next(this.configs);
        this.setUp(this.configs);
    }
    /* TODO: has to be integrated */
    updateConfig(config) {
        const keys = config.name.split('_');
        const page = keys[0];
        const form = keys[1];
        const key = keys[2];
        if (this.configs[page] && this.configs[page][form]) {
            this.configs[page][form][key] = config;
            // this.configChange.next(this.configs);
            this.updateControl(config);
        }
    }
    updateControl(field) {
        const validatorS = this.buildValidators(field.validators);
        const controL = [];
        controL.push(field.value ? field.value : '');
        const options = {
            validators: [],
            updateOn: ''
        };
        if (validatorS) {
            options.validators = validatorS;
        }
        if (field.updateOn) {
            options.updateOn = field.updateOn;
            controL.push(options);
        }
    }
    /**
     * @param name : Page_Form_Field
     * @returns FieldConfig: IField
     */
    getConfigByName(name) {
        const keys = name.split('_');
        const page = keys[0];
        const form = keys[1];
        const key = keys[2];
        if (this.configs[page] && this.configs[page][form]) {
            return this.configs[page][form][key]
                ? this.configs[page][form][key]
                : this.emptyObj;
        }
        else {
            return this.emptyObj;
        }
    }
    /**
     * @param field : IField
     * @returns FormControl
     */
    getFormControl(field) {
        const keys = field.name.split('_');
        const page = keys[0];
        const form = keys[1];
        const key = keys[2];
        if (this.forms.get(page).get(form).get(field.name)) {
            return this.forms.get(page).get(form).get(field.name);
        }
        else {
            return new FormControl('', this.buildValidators(field.validators));
        }
    }
    /**
     * @param name : Page_Form_Field
     * @returns Parent Form of key
     */
    getForm(name) {
        const keys = name.split('_');
        const page = keys[0];
        const form = keys[1];
        if (this.forms.get([page, form])) {
            return this.forms.get(page).get(form);
        }
        else {
            if (this.forms.get(page)) {
                return this.forms.get(page);
            }
            else {
                return new FormGroup({});
            }
        }
    }
    /**
     * @param name : Name of Page
     * @returns Formgroup with forms of Page
     */
    getPage(name) {
        if (this.forms.get(name)) {
            return this.forms.get(name);
        }
        else {
            return null;
        }
    }
    /* TODO: has to be checked */
    getForms() {
        return this.forms.getRawValue();
    }
    /* TODO: has to be checked */
    getConfigs() {
        return this.configs;
    }
    /**
     * @param config : IValidator
     * @returns Array with ValidatorFunctions
     */
    buildValidators(config) {
        const validators = [];
        if (config) {
            if (config.email) {
                validators.push(Validators.email);
            }
            if (config.max) {
                validators.push(Validators.max(config.max));
            }
            if (config.required) {
                validators.push(Validators.required);
            }
            if (config.min) {
                validators.push(Validators.min(config.min));
            }
            if (config.maxLength) {
                validators.push(Validators.maxLength(config.maxLength));
            }
            if (config.minLength) {
                validators.push(Validators.minLength(config.minLength));
            }
            if (config.pattern) {
                validators.push(Validators.pattern(config.pattern));
            }
        }
        return validators;
    }
    /**
     * @param config : { [ <PageName>: { <FormName>: { <FieldName>: IField } } ] }
     * @description : FormGroup will be initalized and added by config [triggert in addConfig()]
     */
    setUp(config) {
        Object.keys(config).forEach(page => {
            const newForm = {};
            const formObj = config[page];
            if (formObj) {
                Object.keys(formObj).forEach(form => {
                    const formArray = {};
                    const forM = formObj[form];
                    Object.keys(forM).forEach(key => {
                        const field = forM[key];
                        const validatorS = this.buildValidators(field.validators);
                        const controL = [];
                        controL.push({
                            value: field.value ? field.value : '',
                            disabled: field.disabled ? field.disabled : false
                        });
                        const options = {
                            validators: [],
                            updateOn: ''
                        };
                        if (validatorS) {
                            options.validators = validatorS;
                        }
                        if (field.updateOn) {
                            options.updateOn = field.updateOn;
                        }
                        controL.push(options);
                        formArray[field.name] = controL;
                    });
                    newForm[form] = this.fb.group(formArray);
                    this.addForm(this.fb.group(newForm), page);
                });
                this.buildCustomValidation(config);
            }
        });
        this.changes = this.forms.getRawValue();
    }
    buildCustomValidation(config) {
        Object.keys(config).forEach(page => {
            const formObj = config[page];
            if (formObj) {
                Object.keys(formObj).forEach(form => {
                    const formArray = {};
                    const forM = formObj[form];
                    Object.keys(forM).forEach(key => {
                        const field = forM[key];
                        if (field.customValidation) {
                            Object.keys(field.customValidation).forEach(validation => {
                                // console.log(field.customValidation[validation]);
                                let fieldToCheck = null;
                                const validationObj = field.customValidation[validation];
                                const fieldD = this.getFormControl(field);
                                // console.log(validationObj.dialog.msg);
                                fieldD.valueChanges.subscribe((val) => {
                                    // console.log(this.tp.transform(validationObj.dialog.msg));
                                    let getChange = false;
                                    if (validationObj.fieldToCheck) {
                                        fieldToCheck = this.getFormControl({ name: validationObj.fieldToCheck });
                                    }
                                    else {
                                        fieldToCheck = fieldD;
                                        getChange = true;
                                    }
                                    switch (validationObj.operator) {
                                        case '<':
                                            break;
                                        case '>':
                                            break;
                                        case '=':
                                            break;
                                        case '!=':
                                            if (getChange) {
                                                if (this.getControlChange(field.name) !== val) {
                                                    // console.log('controlchange');
                                                    this.ds.confirm(validationObj.dialog.msg, () => {
                                                        this.applieChanges();
                                                    }, () => {
                                                        // console.log('reset '+ field.name);
                                                        this.resetControl(field.name);
                                                    });
                                                }
                                            }
                                            else {
                                                if (fieldToCheck && fieldToCheck.value !== val) {
                                                    // console.log('valuechange');
                                                    this.ds.confirm(validationObj.dialog.msg, () => { }, () => {
                                                        this.resetControl(field.name);
                                                    });
                                                }
                                                // } else {
                                            }
                                            break;
                                    }
                                });
                            });
                        }
                    });
                });
            }
        });
    }
    onConfigChange() {
        return this.configChange;
    }
    hasChanges() {
        return difference(this.forms.getRawValue(), this.changes);
    }
    resetForms() {
        if (this.forms) {
            this.forms.patchValue(this.changes);
        }
    }
    resetControl(name) {
        const keys = name.split('_');
        const page = keys[0];
        const form = keys[1];
        if (this.changes[page][form][name] ||
            typeof this.changes[page][form][name] === 'string') {
            this.forms.get(page).get(form).get(name).patchValue(this.changes[page][form][name]);
            // this.resetForm();
            this.getFormControl({ name }).markAsUntouched();
            // this.getFormControl({name}).patchValue(this.changes[page][form][control]);
        }
    }
    getControlChange(name) {
        const keys = name.split('_');
        const page = keys[0];
        const form = keys[1];
        return this.changes[page][form][name];
    }
    applieChanges() {
        this.changes = this.forms.getRawValue();
    }
    update() {
        this.forms.updateValueAndValidity();
    }
}
FormService.ɵprov = i0.ɵɵdefineInjectable({ factory: function FormService_Factory() { return new FormService(i0.ɵɵinject(i1$2.FormBuilder), i0.ɵɵinject(DialogService), i0.ɵɵinject(TranslatePipe)); }, token: FormService, providedIn: "root" });
FormService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
FormService.ctorParameters = () => [
    { type: FormBuilder },
    { type: DialogService },
    { type: TranslatePipe }
];

class BaseFieldComponent {
    constructor(fb, fs, ts) {
        this.fb = fb;
        this.fs = fs;
        this.ts = ts;
        this.MSGerrors = {
            required: () => this.ts.data.required_error,
            maxlength: param => this.ts.data.minLength_error.replace('${param}', param.requiredLength),
            minlength: param => this.ts.data.minLength_error.replace('${param}', param.requiredLength),
            max: param => this.ts.data.max_error.replace('${param}', param.max),
            min: param => this.ts.data.min_error.replace('${param}', param.min),
            pattern: param => this.ts.data.pattern_error.replace('${param}', param.requiredPattern),
            email: () => this.ts.data.email_error,
            matDatepickerParse: () => this.ts.data.datepicker_error
        };
        this.name = 'home_ui_new';
        this.value = '';
        this.disabled = false;
        this.hintlabel = '';
        this.hint = '';
        this.tooltip = '';
        this.htmlType = 'text';
        this.iconAction = new EventEmitter();
        this.autocomplete = 'off';
        this.change = new EventEmitter();
        this.init = true;
    }
    get() {
        return this;
    }
    getErrorMeesage() {
        if (this.control) {
            for (const error in this.control.errors) {
                if ((this.control.errors.hasOwnProperty(error) && this.control.touched) ||
                    this.control.dirty) {
                    return this.getMeesage(error, this.control.errors[error]);
                }
            }
        }
    }
    getMeesage(type, param) {
        // console.log(type);
        if (this.MSGerrors[type](param)) {
            return this.MSGerrors[type](param);
        }
    }
    ngOnInit() {
        this.field = this.fs.getConfigByName(this.placeholder ? this.placeholder : this.name);
        this.setUpConfig(this.field);
        this.form = this.fs.getForm(this.field.name);
        // console.log(this.field);
        // console.log(this.name);
        this.control = this.fs.getFormControl(this.field);
        // console.log(this.control);
        if (this.init) {
            this.fs.addField(this);
        }
        this.init = false;
        this.control.valueChanges.subscribe(val => (this.value = val));
    }
    setUpConfig(config) {
        this.hint = config.hint;
        this.hintlabel = config.hintlabel;
        if (!this.hintlabel) {
            this.hintlabel = config.name + '#hintlabel';
        }
        let tmpReq = false;
        let tmpDis = false;
        if (this.init) {
            tmpReq = this.required ? this.required : null;
            tmpDis = this.disabled ? this.disabled : null;
        }
        this.validators = config.validators;
        this.disabled = config.disabled ? config.disabled : tmpDis;
        this.required = config.validators ? config.validators.required : tmpReq;
        // console.log(this.required);
        this.max = config.validators
            ? config.validators.max
            : this.max
                ? this.max
                : null;
        this.min = config.validators
            ? config.validators.min
            : this.min
                ? this.min
                : null;
        this.maxLength = config.validators
            ? config.validators.maxLength
            : this.maxLength
                ? this.maxLength
                : null;
        this.minLength = config.validators
            ? config.validators.minLength
            : this.minLength
                ? this.minLength
                : null;
        this.value = config.value || '';
        this.htmlType = config.htmlType ? config.htmlType : this.htmlType;
        this.iconBtn = config.icon ? config.icon : this.iconBtn;
        if (config.htmlAttribute && config.htmlAttribute.autocomplete) {
            this.autocomplete = config.htmlAttribute.autocomplete;
        }
        if (this.field.disabled && this.control) {
            this.control.disable();
        }
        this.synchronizeValidator();
    }
    getValue() {
        return this.ts.data[this.value + '#label'] || this.value;
    }
    getName() {
        return this.placeholder ? this.placeholder : this.name;
    }
    synchronizeValidator() {
        const newValidators = {};
        if (this.required) {
            newValidators.required = this.required;
        }
        if (this.max) {
            newValidators.max = this.max;
        }
        if (this.min) {
            newValidators.min = this.min;
        }
        if (this.maxLength) {
            newValidators.maxLength = this.maxLength;
        }
        if (this.minLength) {
            newValidators.minLength = this.minLength;
        }
        if (this.validators && this.validators.pattern) {
            newValidators.pattern = this.validators.pattern;
        }
        if (this.validators && this.validators.email) {
            newValidators.email = this.validators.email;
        }
        this.validators = newValidators;
    }
    getValidators() {
        return this.validators ? this.validators : {};
    }
    getFieldConfig() {
        return this;
    }
    iconAct() {
        this.iconAction.emit({
            name: this.getName(),
            value: this.getValue(),
            btn: this.iconBtn
        });
    }
}
BaseFieldComponent.decorators = [
    { type: Component, args: [{
                selector: 'app-base-field',
                template: '<div></div>'
            },] }
];
BaseFieldComponent.ctorParameters = () => [
    { type: FormBuilder },
    { type: FormService },
    { type: TranslationService }
];
BaseFieldComponent.propDecorators = {
    name: [{ type: Input }],
    value: [{ type: Input }],
    placeholder: [{ type: Input }],
    disabled: [{ type: Input }],
    minLength: [{ type: Input }],
    maxLength: [{ type: Input }],
    min: [{ type: Input }],
    max: [{ type: Input }],
    required: [{ type: Input }],
    form: [{ type: Input }],
    control: [{ type: Input }],
    hintlabel: [{ type: Input }],
    hint: [{ type: Input }],
    tooltip: [{ type: Input }],
    htmlType: [{ type: Input }],
    iconBtn: [{ type: Input }],
    iconAction: [{ type: Input }],
    validators: [{ type: Input }],
    customValidation: [{ type: Input }],
    htmlAttribute: [{ type: Input }],
    autocomplete: [{ type: Input }],
    change: [{ type: Input }]
};

class SelectComponent extends BaseFieldComponent {
    constructor(fb, fs, ts) {
        super(fb, fs, ts);
        this.fb = fb;
        this.fs = fs;
        this.ts = ts;
    }
    ngOnInit() {
        super.ngOnInit();
        this.options = this.fs.getConfigByName(this.name).options ? this.fs.getConfigByName(this.name).options : this.options;
        // console.log(this.options);
        // console.log(this.form);
    }
}
SelectComponent.decorators = [
    { type: Component, args: [{
                selector: 'app-select',
                template: "<ng-container *ngIf=\"form\" [formGroup]=\"form\">\n  <mat-form-field [hintLabel]=\"getName()+'#hintlabel' | translate\">\n    <mat-select [placeholder]=\"getName()+'#label' | translate\"\n                [formControlName]=\"name\"\n                [minlength]=\"validators.minLength\"\n                [maxlength]=\"validators.maxLength\"\n                [matTooltip]=\"getName()+'#tooltip' | translate\"\n                [required]=\"required\"\n                matTooltipDisabled=\"false\"\n                matTooltipHideDelay=\"200\"\n                matTooltipPosition=\"above\"\n                matTooltipShowDelay=\"100\"\n                [value]=\"value\"\n                (selectionChange)=\"change.emit({type: name, value: $event.value})\">\n    <div *ngIf=\"options && options[0] && options[0].key\">\n      <mat-option *ngIf=\"!required\" matTooltip=\"Zur\u00FCcksetzten\" value=\"\">Bitte W\u00E4hlen...</mat-option>\n      <mat-option *ngFor=\"let item of options\" [matTooltip]=\"item.description | translate\" [value]=\"item.value\">\n        {{item.key | translate}}\n      </mat-option>\n    </div>\n    </mat-select>\n    <mat-hint *ngIf=\"hint\" align=\"end\">{{hint}}</mat-hint>\n    <mat-error>\n      {{ getErrorMeesage() }}\n    </mat-error>\n  </mat-form-field>\n</ng-container>\n",
                styles: [""]
            },] }
];
SelectComponent.ctorParameters = () => [
    { type: FormBuilder },
    { type: FormService },
    { type: TranslationService }
];
SelectComponent.propDecorators = {
    options: [{ type: Input }]
};

class TextInputComponent extends BaseFieldComponent {
    constructor(fb, fs, ts) {
        super(fb, fs, ts);
        this.fb = fb;
        this.fs = fs;
        this.ts = ts;
        this.rows = 3;
        this.internalType = 'text';
    }
    ngOnInit() {
        super.ngOnInit();
    }
}
TextInputComponent.decorators = [
    { type: Component, args: [{
                selector: 'app-text-input',
                template: "<ng-container *ngIf=\"form\" [formGroup]=\"form\">\n  <mat-form-field *ngIf=\"htmlType === 'text'\" [hintLabel]=\"getName() + '#hintlabel' | translate\">\n      <input\n        matInput\n        [matTooltip]=\"getName() + '#tooltip' | translate\"\n        [formControlName]=\"name\"\n        [minlength]=\"validators.minLength\"\n        [maxlength]=\"validators.maxLength\"\n        [max]=\"validators.max\"\n        [min]=\"validators.min\"\n        [placeholder]=\"getName() + '#label' | translate\"\n        [required]=\"required\"\n        matTooltipDisabled=\"false\"\n        matTooltipHideDelay=\"200\"\n        matTooltipPosition=\"above\"\n        matTooltipShowDelay=\"100\"\n        [type]=\"internalType\"\n        (change)=\"change.emit({ type: name, value: $event.target.value })\"\n        [value]=\"value\"\n        [autocomplete]=\"autocomplete\"/>\n      <button\n        (click)=\"iconAct()\"\n        *ngIf=\"iconBtn && value\"\n        mat-icon-button\n        matSuffix>\n        <mat-icon>{{ iconBtn }}</mat-icon>\n      </button>\n    <!-- <button (click)=\"value=''\" *ngIf=\"value\" aria-label=\"Clear\" mat-button mat-icon-button matSuffix>\n      <mat-icon>{{iconBtn}}</mat-icon>\n    </button> -->\n    <mat-hint *ngIf=\"hint\">{{ hint }}</mat-hint>\n    <mat-error>\n      {{ getErrorMeesage() }}\n    </mat-error>\n  </mat-form-field>\n  <mat-form-field *ngIf=\"htmlType === 'textarea'\" [hintLabel]=\"getName() + '#hintlabel' | translate\">\n    <textarea\n        matInput\n        [rows]=\"rows\"\n        [matTooltip]=\"getName() + '#tooltip' | translate\"\n        [formControlName]=\"name\"\n        [minlength]=\"validators.minLength\"\n        [maxlength]=\"validators.maxLength\"\n        [placeholder]=\"getName() + '#label' | translate\"\n        [required]=\"required\"\n        matTooltipDisabled=\"false\"\n        matTooltipHideDelay=\"200\"\n        matTooltipPosition=\"above\"\n        matTooltipShowDelay=\"100\"\n        [type]=\"htmlType\"\n        (change)=\"change.emit({ type: name, value: $event.target.value })\"\n        [value]=\"value\">\n      </textarea>\n  <mat-hint *ngIf=\"hint\">{{ hint }}</mat-hint>\n  <mat-error>\n    {{ getErrorMeesage() }}\n  </mat-error>\n</mat-form-field>\n</ng-container>\n",
                styles: ["mat-form-field{width:100%;max-width:auto}\n"]
            },] }
];
TextInputComponent.ctorParameters = () => [
    { type: FormBuilder },
    { type: FormService },
    { type: TranslationService }
];
TextInputComponent.propDecorators = {
    rows: [{ type: Input }],
    internalType: [{ type: Input }]
};

class DateInputComponent extends BaseFieldComponent {
    constructor(fb, fs, dateAdapter, ts) {
        super(fb, fs, ts);
        this.fb = fb;
        this.fs = fs;
        this.dateAdapter = dateAdapter;
        this.ts = ts;
        dateAdapter.setLocale(ts.lang);
        ts.onLangChange.subscribe(lang => dateAdapter.setLocale(lang));
    }
    ngOnInit() {
        super.ngOnInit();
    }
    isMoment(date) {
        if (!moment.isMoment(date.value)) {
            date.patchValue(moment(date.value, 'L', 'de', true));
        }
    }
    keyup() {
        this.isMoment(this.control);
        this.control.patchValue(this.control.value.add(1, 'd'));
    }
    keydown() {
        this.isMoment(this.control);
        this.control.patchValue(this.control.value.subtract(1, 'd'));
    }
}
DateInputComponent.decorators = [
    { type: Component, args: [{
                selector: 'app-date-input',
                template: "<ng-container *ngIf=\"form\" [formGroup]=\"form\">\n  <mat-form-field [hintLabel]=\"getName()+'#hintlabel' | translate\">\n    <input matInput\n           [placeholder]=\"getName()+'#label' | translate\"\n           [formControlName]=\"name\"\n           [min]=\"validators.min\"\n           [max]=\"validators.max\"\n           [matTooltip]=\"getName()+'#tooltip' | translate\"\n           [required]=\"required\"\n           matTooltipDisabled=\"false\"\n           matTooltipHideDelay=\"200\"\n           matTooltipPosition=\"above\"\n           matTooltipShowDelay=\"100\"\n           [value]=\"getValue()\"\n           (keyup.arrowup)=\"keyup()\"\n           (keyup.arrowdown)=\"keydown()\"\n           [matDatepicker]=\"picker\">\n    <mat-datepicker-toggle matSuffix [for]=\"picker\"></mat-datepicker-toggle>\n    <mat-datepicker #picker></mat-datepicker>\n    <mat-hint *ngIf=\"hint\">{{hint}}</mat-hint>\n    <mat-error>\n      {{ getErrorMeesage() }}\n    </mat-error>\n  </mat-form-field>\n</ng-container>\n",
                styles: [""]
            },] }
];
DateInputComponent.ctorParameters = () => [
    { type: FormBuilder },
    { type: FormService },
    { type: DateAdapter },
    { type: TranslationService }
];

class FileInputComponent extends BaseFieldComponent {
    constructor(fb, fs, ts) {
        super(fb, fs, ts);
        this.fb = fb;
        this.fs = fs;
        this.ts = ts;
    }
    ngOnInit() {
        super.ngOnInit();
        // console.log(this.name);
        // console.log(this.control);
        // console.log(this.form);
    }
    onFileSelected() {
        const inputNode = document.querySelector('#file');
        if (typeof (FileReader) !== 'undefined' && typeof (inputNode.files[0]) !== 'undefined') {
            const reader = new FileReader();
            reader.onload = (e) => {
                // console.log(e);
                this.srcResult = e.target.result;
            };
            reader.readAsArrayBuffer(inputNode.files[0]);
            // console.log(reader);
        }
    }
}
FileInputComponent.decorators = [
    { type: Component, args: [{
                selector: 'app-file-input',
                template: "<ng-container *ngIf=\"form\" [formGroup]=\"form\">\n  <button type=\"button\" mat-raised-button (click)=\"fileInput.click()\">\n    Choose File\n  </button>\n  <input class=\"mat-input\" (change)=\"onFileSelected()\" #fileInput type=\"file\" id=\"file\"\n    [formControlName]=\"name\">\n</ng-container>",
                styles: [""]
            },] }
];
FileInputComponent.ctorParameters = () => [
    { type: FormBuilder },
    { type: FormService },
    { type: TranslationService }
];
FileInputComponent.propDecorators = {
    srcResult: [{ type: Input }]
};

const _filter = (opt, value, ts) => {
    const filterValue = value.toLowerCase();
    if (opt) {
        if (typeof opt[0] === 'string') {
            return opt.filter(item => checkKey(ts, item, filterValue));
        }
        else {
            return opt.filter(item => checkKey(ts, item.name, filterValue));
        }
    }
    else {
        return [];
    }
};
function checkKey(ts, item, value) {
    if (item.toLocaleLowerCase().indexOf(value) >= 0) {
        return true;
    }
    if (ts.data[item + '#label'] && ts.data[item + '#label'].toLocaleLowerCase().indexOf(value) >= 0) {
        return true;
    }
    return false;
}
class AutocompleteComponent extends BaseFieldComponent {
    constructor(fb, fs, ts) {
        super(fb, fs, ts);
        this.fb = fb;
        this.fs = fs;
        this.ts = ts;
        this.config = {
            groupBy: true
        };
    }
    ngOnInit() {
        super.ngOnInit();
        if (this.config.groupBy) {
            this.filteredStates = this.control.valueChanges.pipe(startWith(''), map(option => this._filterGroup(option)));
        }
        else {
            this.filteredStates = this.control.valueChanges.pipe(startWith(''), map(option => this._filterStates(option)));
        }
        // console.log(this.options);
        // console.log(this.config);
    }
    _filterStates(value) {
        // console.log('options', this.options);
        // console.log('options', this.options.length);
        const filterValue = value.toLowerCase();
        return this.options.filter(option => option.toLowerCase().indexOf(filterValue) > -1);
    }
    _filterGroup(value) {
        // console.log(this.filteredStates);
        // console.log(this.options);
        if (value && this.options[0].name) {
            return this.options
                .map((group) => ({
                name: group.name,
                children: _filter(group.children, value, this.ts)
            }))
                .filter((group) => group.name.length > 0);
        }
        // console.log(this.options);
        return this.options;
    }
}
AutocompleteComponent.decorators = [
    { type: Component, args: [{
                // tslint:disable-next-line: component-selector
                selector: 'app-autocomplete',
                template: "<ng-container *ngIf=\"form\" [formGroup]=\"form\">\n  <mat-form-field [hintLabel]=\"getName() + '#hintlabel' | translate\">\n    <input\n      matInput\n      [placeholder]=\"getName() + '#label' | translate\"\n      [formControlName]=\"name\"\n      type=\"search\"\n      [minlength]=\"validators.minLength\"\n      [maxlength]=\"validators.maxLength\"\n      [required]=\"validators.required\"\n      [matTooltip]=\"getName() + '#tooltip' | translate\"\n      matTooltipDisabled=\"false\"\n      matTooltipHideDelay=\"200\"\n      matTooltipPosition=\"above\"\n      matTooltipShowDelay=\"100\"\n      [value]=\"getValue()\"\n      (change)=\"change.emit({ type: name, value: $event.target.value })\"\n      [matAutocomplete]=\"auto\"\n      [autocomplete]=\"autocomplete\"/>\n    <mat-autocomplete #auto=\"matAutocomplete\">\n      <ng-container *ngIf=\"config.groupBy\">\n        <mat-optgroup\n          *ngFor=\"let group of filteredStates | async\"\n          [label]=\"group.name\">\n          <mat-option\n            *ngFor=\"let element of group.children\"\n            [value]=\"element.name\">\n            {{element.name}}\n          </mat-option>\n        </mat-optgroup>\n      </ng-container>\n      <ng-container *ngIf=\"!config.groupBy\">\n        <mat-option\n          *ngFor=\"let state of filteredStates | async\"\n          [value]=\"state\">\n          <span>{{ state }}</span>\n        </mat-option>\n      </ng-container>\n    </mat-autocomplete>\n    <mat-hint *ngIf=\"hint\" align=\"end\">{{ hint }}</mat-hint>\n    <mat-error>\n      {{ getErrorMeesage() }}\n    </mat-error>\n  </mat-form-field>\n</ng-container>\n",
                styles: [""]
            },] }
];
AutocompleteComponent.ctorParameters = () => [
    { type: FormBuilder },
    { type: FormService },
    { type: TranslationService }
];
AutocompleteComponent.propDecorators = {
    options: [{ type: Input }],
    config: [{ type: Input }]
};

class CheckboxComponent extends BaseFieldComponent {
    constructor(fb, fs, ts) {
        super(fb, fs, ts);
        this.fb = fb;
        this.fs = fs;
        this.ts = ts;
        this.position = 'before';
    }
    ngOnInit() {
        super.ngOnInit();
    }
}
CheckboxComponent.decorators = [
    { type: Component, args: [{
                selector: 'app-checkbox',
                template: "<ng-container *ngIf=\"form\" [formGroup]=\"form\">\n    <div>\n      <mat-checkbox\n        [value]=\"value\"\n        [labelPosition]=\"position\"\n        [formControlName]=\"name\"\n        (change)=\"change.emit({ type: name, value: $event.checked })\"\n        [matTooltip]=\"getName() + '#tooltip' | translate\"\n        matTooltipDisabled=\"false\"\n        matTooltipHideDelay=\"200\"\n        matTooltipPosition=\"above\"\n        matTooltipShowDelay=\"100\">\n        {{ getName() + \"#label\" | translate }}\n      </mat-checkbox>\n    </div>\n</ng-container>\n\n<!--div *ngIf=\"task.options\">\n  <mat-checkbox\n    [checked]=\"allComplete\"\n    [color]=\"task.color\"\n    [indeterminate]=\"someComplete()\"\n    (change)=\"setAll($event.checked)\"\n    [labelPosition]=\"position\"\n    (change)=\"change.emit({ type: name, value: $event.checked })\"\n    [disabled]=\"disabled\"\n    [matTooltip]=\"getName() + '#tooltip' | translate\"\n    matTooltipDisabled=\"false\"\n    matTooltipHideDelay=\"200\"\n    matTooltipPosition=\"above\"\n    matTooltipShowDelay=\"100\">\n    {{ getName() + \"#label\" | translate }}\n  </mat-checkbox>\n  <ul>\n    <li *ngFor=\"let subtask of task.options\">\n      <mat-checkbox\n        [(ngModel)]=\"subtask.completed\"\n        [color]=\"subtask.color\"\n        (ngModelChange)=\"updateAllComplete()\"\n      >\n        {{ subtask.name }}\n      </mat-checkbox>\n    </li>\n  </ul>\n</div-->\n",
                styles: [""]
            },] }
];
CheckboxComponent.ctorParameters = () => [
    { type: FormBuilder },
    { type: FormService },
    { type: TranslationService }
];
CheckboxComponent.propDecorators = {
    position: [{ type: Input }]
};

class RadiobuttonComponent extends BaseFieldComponent {
    constructor(fb, fs, ts) {
        super(fb, fs, ts);
        this.fb = fb;
        this.fs = fs;
        this.ts = ts;
    }
    ngOnInit() {
        super.ngOnInit();
        // console.log(this.options);
        // console.log(this.form);
    }
}
RadiobuttonComponent.decorators = [
    { type: Component, args: [{
                selector: 'app-radiobutton',
                template: "<ng-container *ngIf=\"form\" [formGroup]=\"form\">\n  <mat-form-field [hintLabel]=\"getName()+'#hintlabel' | translate\">\n  <label>{{ getName()+'#label' | translate }}</label>\n    <mat-radio-group\n                [formControlName]=\"name\"\n                [matTooltip]=\"getName()+'#tooltip' | translate\"\n                [required]=\"required\"\n                matTooltipDisabled=\"false\"\n                matTooltipHideDelay=\"200\"\n                matTooltipPosition=\"above\"\n                matTooltipShowDelay=\"100\"\n                [value]=\"value\"\n                (selectionChange)=\"change.emit({type: name, value: $event.value})\"\n    >\n    <div *ngIf=\"options && options[0].key\">\n      <mat-radio-button *ngFor=\"let item of options\" [matTooltip]=\"item\" [value]=\"item.value\">\n        {{item.key}}\n      </mat-radio-button>\n    </div>\n    </mat-radio-group>\n    <mat-hint *ngIf=\"hint\" align=\"end\">{{hint}}</mat-hint>\n    <mat-error>\n      {{ getErrorMeesage() }}\n    </mat-error>\n  </mat-form-field>\n</ng-container>\n",
                styles: [""]
            },] }
];
RadiobuttonComponent.ctorParameters = () => [
    { type: FormBuilder },
    { type: FormService },
    { type: TranslationService }
];
RadiobuttonComponent.propDecorators = {
    options: [{ type: Input }]
};

class SliderComponent extends BaseFieldComponent {
    constructor(fb, fs, ts) {
        super(fb, fs, ts);
        this.fb = fb;
        this.fs = fs;
        this.ts = ts;
    }
    ngOnInit() {
        super.ngOnInit();
        if (!this.config && this.field.config) {
            // console.log(this.field.config);
            this.config = this.field.config;
        }
    }
    getTickIntervall() {
        if (this.config.showTicks) {
            return this.config.tickInterval > 0 ? this.config.tickInterval : 'auto';
        }
        return 0;
    }
}
SliderComponent.decorators = [
    { type: Component, args: [{
                selector: 'app-slider',
                template: "<ng-container [formGroup]=\"form\">\n    <mat-slider\n      [disabled]=\"disabled\"\n      [invert]=\"config.inverted\"\n      [max]=\"max\"\n      [min]=\"min\"\n      [step]=\"config.step\"\n      [thumbLabel]=\"config.showThumb\"\n      [tickInterval]=\"getTickIntervall()\"\n      [formControlName]=\"name\"\n      [vertical]=\"config.vertical\"\n      [matTooltip]=\"getName() + '#tooltip' | translate\"\n      matTooltipDisabled=\"false\"\n      matTooltipHideDelay=\"200\"\n      matTooltipPosition=\"above\"\n      matTooltipShowDelay=\"100\">\n    </mat-slider>\n    <mat-hint>{{name+'#label' | translate}}</mat-hint>\n</ng-container>\n",
                styles: ["mat-slider{width:100%;max-width:auto}\n"]
            },] }
];
SliderComponent.ctorParameters = () => [
    { type: FormBuilder },
    { type: FormService },
    { type: TranslationService }
];
SliderComponent.propDecorators = {
    config: [{ type: Input }]
};

class DataFlattnerService {
    constructor() {
    }
    static isFlat(object) {
        if (!(typeof object === 'object')) {
            return false;
        }
        return true;
    }
    /** isBuffer
     * used for flatten unflatten
     * @obj
     */
    static isBuffer(obj) {
        return obj != null && obj.constructor != null &&
            typeof obj.constructor.isBuffer === 'function' && obj.constructor.isBuffer(obj);
    }
    static flatten(target, opts) {
        opts = opts || {};
        const delimiter = opts.delimiter || '.';
        const maxDepth = opts.maxDepth;
        const output = {};
        function step(object, prev, currentDepth) {
            currentDepth = currentDepth || 1;
            Object.keys(object).forEach((key) => {
                const value = object[key];
                const isArray = opts.safe && Array.isArray(value);
                const type = Object.prototype.toString.call(value);
                const isBuffer = DataFlattnerService.isBuffer(value);
                const isObject = (type === '[object Object]' ||
                    type === '[object Array]');
                const newKey = prev ? prev + delimiter + key : key;
                if (!isArray && !isBuffer && isObject && Object.keys(value).length &&
                    (!opts.maxDepth || currentDepth < maxDepth)) {
                    return step(value, newKey, currentDepth + 1);
                }
                output[newKey] = value;
            });
        }
        step(target);
        return output;
    }
    static unflatten(target, opts) {
        opts = opts || {};
        const delimiter = opts.delimiter || '.';
        const overwrite = opts.overwrite;
        const result = {};
        const isBuffer = DataFlattnerService.isBuffer(target);
        if (isBuffer || Object.prototype.toString.call(target) !== '[object Object]') {
            return target;
        }
        function getKey(key) {
            const parsedKey = key;
            return (isNaN(parsedKey) ||
                key.indexOf('.') !== -1 ||
                opts.object) ? key : parsedKey;
        }
        const sortKeys = Object.keys(target).sort((keyA, keyB) => {
            return keyA.length - keyB.length;
        });
        sortKeys.forEach((key) => {
            const split = key.split(delimiter);
            let key1 = getKey(split.shift());
            let key2 = getKey(split[0]);
            let recipient = result;
            while (key2 !== undefined) {
                const type = Object.prototype.toString.call(recipient[key1]);
                const isObject = (type === '[object Object]' ||
                    type === '[object Array]');
                if (!overwrite && !isObject && typeof recipient[key1] !== 'undefined') {
                    return;
                }
                if ((overwrite && !isObject) || (!overwrite && recipient[key1] == null)) {
                    recipient[key1] = (typeof key2 === 'number' &&
                        !opts.object ? [] : {});
                }
                recipient = recipient[key1];
                if (split.length > 0) {
                    key1 = getKey(split.shift());
                    key2 = getKey(split[0]);
                }
            }
            recipient[key1] = DataFlattnerService.unflatten(target[key], opts);
        });
        return result;
    }
}
DataFlattnerService.ɵprov = i0.ɵɵdefineInjectable({ factory: function DataFlattnerService_Factory() { return new DataFlattnerService(); }, token: DataFlattnerService, providedIn: "root" });
DataFlattnerService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
DataFlattnerService.ctorParameters = () => [];

class AutoSearch {
}

class ConfigService {
    constructor(http) {
        this.http = http;
        this.dataChange = new BehaviorSubject([]);
        this.emptyObj = {
            name: 'home_ui_new'
        };
        this.flatControlls = [];
        // console.log(this.flatControlls);
    }
    buildTree(config) {
        // console.log(config);
        const entries = [];
        for (const page in config) {
            if (page) {
                for (const formN in config[page]) {
                    if (config[page][formN]) {
                        const subLvl = [];
                        const form = config[page][formN];
                        // console.log(form);
                        for (const [key, value] of Object.entries(form)) {
                            // console.log(`${key}: ${value}`);
                            subLvl.push(value.name);
                            // children.push(value.name);
                        }
                        const tmpData = [
                            {
                                name: formN,
                                children: subLvl
                            }
                        ];
                        entries.push(tmpData);
                    }
                }
            }
        }
        // DataFlattnerService.flatten(tmpData)
        // this.flatControlls = tmpData;
        // console.log("newtree", this.flatControlls);
    }
    get data() {
        return this.dataChange.value;
    }
    /**
     * Build the file structure tree. The `value` is the Json object, or a sub-tree of a Json object.
     * The return value is the list of `AutoSearch`.
     */
    buildFileTree(obj, level) {
        return Object.keys(obj).reduce((accumulator, key) => {
            const value = obj[key];
            // console.log(value);
            const node = new AutoSearch();
            node.name = key;
            if (value != null) {
                if (typeof value === 'object' && level < 2) {
                    node.children = this.buildFileTree(value, level + 1);
                }
                else {
                    if (level === 2) {
                        node.name = value.name;
                    }
                    else {
                        node.name = value;
                    }
                }
            }
            const data = accumulator.concat(node);
            this.dataChange.next(data);
            return accumulator.concat(node);
        }, []);
    }
    getControlls() {
        return this.flatControlls;
    }
    getFlatControlls() {
        return DataFlattnerService.flatten(this.flatControlls);
    }
    getConfigByName(name) {
        const keys = name.split('_');
        const page = keys[0];
        const form = keys[1];
        const key = keys[2];
        if (this.configs[page] && this.configs[page][form]) {
            return this.configs[page][form][key]
                ? this.configs[page][form][key]
                : this.emptyObj;
        }
        else {
            return this.emptyObj;
        }
    }
    getAppConfigs(appData) {
        let data = {};
        Object.keys(appData).forEach(page => {
            const formObj = appData[page];
            if (formObj) {
                Object.keys(formObj).forEach(form => {
                    const forM = formObj[form];
                    Object.keys(forM).forEach(key => {
                        const field = forM[key];
                        if (this.configs[page] && this.configs[page][form] && this.configs[page][form][key]) {
                            // data[page][form][key] = field;
                            merge(data, { [page]: { [form]: { [key]: field } } });
                        }
                    });
                });
            }
        });
        return data;
    }
    getFBConfig(appData) {
        let data = {};
        Object.keys(appData).forEach(page => {
            const formObj = appData[page];
            if (formObj) {
                Object.keys(formObj).forEach(form => {
                    const forM = formObj[form];
                    Object.keys(forM).forEach(key => {
                        const field = forM[key];
                        if (!this.configs[page] || !this.configs[page][form] || !this.configs[page][form][key]) {
                            // data[page][form][key] = field;
                            merge(data, { [page]: { [form]: { [key]: field } } });
                        }
                    });
                });
            }
        });
        return data;
    }
}
ConfigService.ɵprov = i0.ɵɵdefineInjectable({ factory: function ConfigService_Factory() { return new ConfigService(i0.ɵɵinject(i1$1.HttpClient)); }, token: ConfigService, providedIn: "root" });
ConfigService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
ConfigService.ctorParameters = () => [
    { type: HttpClient }
];

class CsvConfigConsts {
}
CsvConfigConsts.EOL = '\r\n';
CsvConfigConsts.BOM = '\ufeff';
CsvConfigConsts.DEFAULT_FIELD_SEPARATOR = ',';
CsvConfigConsts.DEFAULT_DECIMAL_SEPARATOR = '.';
CsvConfigConsts.DEFAULT_QUOTE = '"';
CsvConfigConsts.DEFAULT_SHOW_TITLE = false;
CsvConfigConsts.DEFAULT_TITLE = 'My Report';
CsvConfigConsts.DEFAULT_FILENAME = 'mycsv.csv';
CsvConfigConsts.DEFAULT_SHOW_LABELS = false;
CsvConfigConsts.DEFAULT_USE_BOM = true;
CsvConfigConsts.DEFAULT_HEADER = [];
CsvConfigConsts.DEFAULT_OBJ_HEADER = {};
CsvConfigConsts.DEFAULT_USE_OBJ_HEADER = false;
CsvConfigConsts.DEFAULT_USE_HEADER = false;
CsvConfigConsts.DEFAULT_NO_DOWNLOAD = false;
CsvConfigConsts.DEFAULT_NULL_TO_EMPTY_STRING = false;
const ConfigDefaults = {
    filename: CsvConfigConsts.DEFAULT_FILENAME,
    fieldSeparator: CsvConfigConsts.DEFAULT_FIELD_SEPARATOR,
    quoteStrings: CsvConfigConsts.DEFAULT_QUOTE,
    decimalseparator: CsvConfigConsts.DEFAULT_DECIMAL_SEPARATOR,
    showLabels: CsvConfigConsts.DEFAULT_SHOW_LABELS,
    showTitle: CsvConfigConsts.DEFAULT_SHOW_TITLE,
    title: CsvConfigConsts.DEFAULT_TITLE,
    useBom: CsvConfigConsts.DEFAULT_USE_BOM,
    headers: CsvConfigConsts.DEFAULT_HEADER,
    objHeader: CsvConfigConsts.DEFAULT_OBJ_HEADER,
    useObjHeader: CsvConfigConsts.DEFAULT_USE_OBJ_HEADER,
    useHeader: CsvConfigConsts.DEFAULT_USE_HEADER,
    noDownload: CsvConfigConsts.DEFAULT_NO_DOWNLOAD,
    nullToEmptyString: CsvConfigConsts.DEFAULT_NULL_TO_EMPTY_STRING
};
class AngularCsv {
    constructor(DataJSON, filename, options) {
        this.csv = '';
        let config = options || {};
        this.data = typeof DataJSON !== 'object' ? JSON.parse(DataJSON) : DataJSON;
        this._options = objectAssign({}, ConfigDefaults, config);
        if (this._options.filename) {
            this._options.filename = filename;
        }
        this.generateCsv();
    }
    /**
     * Check if is Float
     * @param input: any
     */
    static isFloat(input) {
        return +input === input && (!isFinite(input) || Boolean(input % 1));
    }
    /**
     * Generate and Download Csv
     */
    generateCsv() {
        if (this._options.useBom) {
            this.csv += CsvConfigConsts.BOM;
        }
        if (this._options.showTitle) {
            this.csv += this._options.title + '\r\n\n';
        }
        if (this._options.useObjHeader &&
            Object.keys(this._options.objHeader).length > 0) {
            this.getHeaderFromObj();
            this.getBodyAccordingHeader();
        }
        else {
            this.getHeaders();
            this.getBody();
        }
        if (this.csv === '') {
            console.log('Invalid data');
            return '';
        }
        if (this._options.noDownload) {
            return this.csv;
        }
        let blob = new Blob([this.csv], { type: 'text/csv;charset=utf8;' });
        if (navigator.msSaveBlob) {
            let filename = this._options.filename.replace(/ /g, '_') + '.csv';
            navigator.msSaveBlob(blob, filename);
        }
        else {
            let uri = 'data:attachment/csv;charset=utf-8,' + encodeURI(this.csv);
            let link = document.createElement('a');
            link.href = URL.createObjectURL(blob);
            link.setAttribute('target', '_blank');
            link.setAttribute('visibility', 'hidden');
            link.download = this._options.filename.replace(/ /g, '_') + '.csv';
            document.body.appendChild(link);
            link.click();
            document.body.removeChild(link);
        }
        return '';
    }
    /**
     * Create Headers
     */
    getHeaders() {
        if (this._options.headers.length > 0) {
            const { headers } = this._options;
            let row = headers.reduce((headerRow, header) => {
                return headerRow + header + this._options.fieldSeparator;
            }, '');
            row = row.slice(0, -1);
            this.csv += row + CsvConfigConsts.EOL;
        }
    }
    /**
     * Create Header from Object
     */
    getHeaderFromObj() {
        if (Object.keys(this._options.objHeader).length > 0) {
            let row = '';
            Object.keys(this._options.objHeader).forEach(key => {
                row += this._options.objHeader[key] + this._options.fieldSeparator;
            });
            row = row.slice(0, -1);
            this.csv += row + CsvConfigConsts.EOL;
        }
    }
    /**
     * Create Body according to obj header
     */
    getBodyAccordingHeader() {
        // tslint:disable-next-line: prefer-for-of
        for (let i = 0; i < this.data.length; i++) {
            let row = '';
            if (this._options.useObjHeader &&
                Object.keys(this._options.objHeader).length > 0) {
                Object.keys(this._options.objHeader).forEach(key => {
                    row +=
                        this.formatData(this.data[i][key]) + this._options.fieldSeparator;
                });
            }
            row = row.slice(0, -1);
            this.csv += row + CsvConfigConsts.EOL;
        }
    }
    /**
     * Create Body
     */
    getBody() {
        // tslint:disable-next-line: prefer-for-of
        for (let i = 0; i < this.data.length; i++) {
            let row = '';
            if (this._options.useHeader && this._options.headers.length > 0) {
                for (const index of this._options.headers) {
                    row +=
                        this.formatData(this.data[i][index]) + this._options.fieldSeparator;
                }
            }
            else {
                for (const index in this.data[i]) {
                    if (this.data[i][index]) {
                        row +=
                            this.formatData(this.data[i][index]) +
                                this._options.fieldSeparator;
                    }
                }
            }
            row = row.slice(0, -1);
            this.csv += row + CsvConfigConsts.EOL;
        }
    }
    /**
     * Format Data
     * @param data: any
     */
    formatData(data) {
        if (this._options.decimalseparator === 'locale' &&
            AngularCsv.isFloat(data)) {
            return data.toLocaleString();
        }
        if (this._options.decimalseparator !== '.' && AngularCsv.isFloat(data)) {
            return data.toString().replace('.', this._options.decimalseparator);
        }
        if (typeof data === 'string') {
            data = data.replace(/"/g, '""');
            if (this._options.quoteStrings ||
                data.indexOf(',') > -1 ||
                data.indexOf('\n') > -1 ||
                data.indexOf('\r') > -1) {
                data = this._options.quoteStrings + data + this._options.quoteStrings;
            }
            return data;
        }
        if (this._options.nullToEmptyString) {
            if (!data) {
                return (data = '');
            }
            else {
                return data;
            }
        }
        if (typeof data === 'boolean') {
            return data ? 'TRUE' : 'FALSE';
        }
        return data;
    }
    getCsvData() {
        return this.csv;
    }
}
let hasOwnProperty = Object.prototype.hasOwnProperty;
let propIsEnumerable = Object.prototype.propertyIsEnumerable;
/**
 * Convet to Object
 * @param val:any
 */
function toObject(val) {
    if (val === null || val === undefined) {
        throw new TypeError('Object.assign cannot be called with null or undefined');
    }
    return Object(val);
}
/**
 * Assign data  to new Object
 * @param  target: any
 * @param  source: any[]
 */
function objectAssign(target, ...source) {
    let from;
    let to = toObject(target);
    let symbols;
    for (let s = 1; s < arguments.length; s++) {
        from = Object(arguments[s]);
        for (const key in from) {
            if (hasOwnProperty.call(from, key)) {
                to[key] = from[key];
            }
        }
        if (Object.getOwnPropertySymbols) {
            symbols = Object.getOwnPropertySymbols(from);
            // tslint:disable-next-line: prefer-for-of
            for (let i = 0; i < symbols.length; i++) {
                if (propIsEnumerable.call(from, symbols[i])) {
                    to[symbols[i]] = from[symbols[i]];
                }
            }
        }
    }
    return to;
}

var TableType;
(function (TableType) {
    TableType["USER"] = "USER";
    TableType["FILE"] = "FILE";
    TableType["GENERIC"] = "GENERIC";
})(TableType || (TableType = {}));
// TODO: A structure that helps generation the table
// TODO: Make the action buttons configurable. Eg.: disabled
// TODO: add for CodeTables an entry in getDisplayRepresentation()
class TableComponent {
    constructor(dialog, ts) {
        this.dialog = dialog;
        this.ts = ts;
        this.selection = new SelectionModel(true, []);
        this.collumnsToBeDisplayed = [];
        this.initialColumns = [];
        this.dataSource = new MatTableDataSource();
        this.resultsLength = 0;
        this.filterControl = new FormControl('');
        this.displayedColumns = [];
        this.data = [];
        this.edit = new EventEmitter();
        this.download = new EventEmitter();
        this.delete = new EventEmitter();
        this.deleteBulk = new EventEmitter();
    }
    applyFilter(filterValue) {
        this.dataSource.filter = event.target.value;
        this.selection.clear();
    }
    /** Whether the number of selected elements matches the total number of rows. */
    isAllSelected() {
        const numSelected = this.selection.selected.length;
        const numRows = this.dataSource.filteredData.length;
        return numSelected === numRows;
    }
    /** Selects all rows if they are not all selected; otherwise clear selection. */
    masterToggle() {
        this.isAllSelected() ?
            this.selection.clear() :
            this.dataSource.filteredData.forEach(row => this.selection.select(row));
    }
    ngOnInit() {
        this.dataSource.data = this.data || [];
        if (this.viewOptions.showDeleteAllButton !== false) {
            this.viewOptions.showDeleteAllButton = true;
        }
        if (this.viewOptions.showCheckbox) {
            this.displayedColumns.unshift({ collumnName: 'select' });
        }
        if (this.viewOptions.showActions) {
            this.displayedColumns.push({ collumnName: 'actions' });
        }
        this.collumnsToBeDisplayed = this.displayedColumns.map(header => header.collumnName);
        this.initialColumns = this.displayedColumns.filter((column) => column.collumnName !== '')
            .map((column) => column.collumnName);
        this.dataSource.filterPredicate = (data, filter) => this.customFilterBasedOnDisplayColumns(data, filter);
    }
    ngAfterViewInit() {
        this.dataSource.paginator = this.paginator;
        this.dataSource.sort = this.sort;
        if (this.viewOptions.dateStringToDateFilter) {
            this.dataSource.sortingDataAccessor = (item, property) => {
                switch (property) {
                    case this.viewOptions.dateStringToDateFilter:
                        {
                            return moment(item[property], 'L', 'de', true).unix();
                        }
                        ;
                    default: return item[property];
                }
            };
        }
    }
    ngOnChanges(changes) {
        this.selection.clear();
        if (changes['data']) {
            this.data = changes.data.currentValue || [];
            this.dataSource.data = this.data;
            this.resultsLength = this.data.length;
            this.dataSource.filter = '';
            this.filterControl.patchValue('');
            if (this.paginator) {
                this.dataSource.paginator.firstPage();
            }
        }
    }
    onEdit(row) {
        this.edit.emit(row);
    }
    onDownload(row) {
        this.download.emit(row);
    }
    onDeleteRecord(row) {
        this.delete.emit(row);
        this.selection.clear();
    }
    onDeleteSelectedRecords() {
        const filteredDatasource = this.dataSource.filteredData.filter(item => this.selection.selected.indexOf(item) >= 0);
        this.deleteBulk.emit(filteredDatasource);
        this.selection.clear();
    }
    customFilterBasedOnDisplayColumns(data, filter) {
        for (const columnName of this.initialColumns) {
            // console.log(data);
            // console.log(columnName);
            if (data[columnName] && data[columnName].toString().trim().toLowerCase().indexOf(filter.toLowerCase()) >= 0) {
                return true;
            }
        }
        return false;
    }
    getDisplayData(colums) {
        const result = [];
        // tslint:disable-next-line: prefer-for-of
        for (let i = 0; i < this.data.length; i++) {
            const row = {};
            // tslint:disable-next-line: prefer-for-of
            for (let y = 0; y < colums.length; y++) {
                row[colums[y].collumnName] = this.data[i][colums[y].collumnName] ? this.data[i][colums[y].collumnName] : ' ';
            }
            // console.log('row', row);
            result.push(row);
        }
        // console.log('result', result);
        return result;
    }
    getFilteredDisplayData(colums) {
        const result = [];
        // tslint:disable-next-line: prefer-for-of
        for (let i = 0; i < this.dataSource.filteredData.length; i++) {
            const row = {};
            // tslint:disable-next-line: prefer-for-of
            for (let y = 0; y < colums.length; y++) {
                row[colums[y].collumnName] = this.dataSource.filteredData[i][colums[y].collumnName];
            }
            // console.log('row', row);
            result.push(row);
        }
        // console.log('result', result);
        return result;
    }
    refresh() {
        this.dataSource.data = this.data;
    }
    csvExport() {
        let columns = Object.assign([], this.displayedColumns);
        let columnNames = Object.assign([], this.displayedColumns.map(header => header.collumnKey ?
            this.ts.transform(header.collumnKey) : header.collumnName));
        columns = columns.filter((el) => {
            return el.collumnName !== '' && el.collumnName !== 'select' && el.collumnName !== 'actions';
        });
        columnNames = columnNames.filter((el) => {
            return el !== '' && el !== 'select' && el !== 'actions';
        });
        // columns.
        // console.log(columns);
        const tmpData = this.getDisplayData(columns);
        // console.log(tmpData);
        // const data = this.getFilteredDisplayData(columns);
        const options = {
            fieldSeparator: ';',
            quoteStrings: '"',
            decimalseparator: '.',
            showLabels: true,
            showTitle: false,
            title: 'Formbuilder',
            useBom: true,
            noDownload: false,
            headers: columnNames
        };
        // console.log(columns);
        const file = new AngularCsv(tmpData, 'Formbuilder', options);
        // console.log('csv', file);
    }
}
TableComponent.decorators = [
    { type: Component, args: [{
                selector: 'app-table',
                template: "<ng-container *ngIf=\"viewOptions.searchable\">\n  <mat-form-field\n    [ngClass]=\"viewOptions.showCSVExport ? 'short-filter' : 'long-filter'\">\n    <input\n      matInput\n      [formControl]=\"filterControl\"\n      (keyup)=\"applyFilter($event.target.value)\"\n      placeholder=\"Filter\"\n      autocomplete=\"off\"\n      maxlength=\"250\"\n    />\n  </mat-form-field>\n</ng-container>\n<div class=\"row\">\n  <button\n    *ngIf=\"viewOptions.showCSVExport\"\n    mat-icon-button\n    (click)=\"csvExport()\"\n    id=\"table-export\">\n    <mat-icon>vertical_align_bottom</mat-icon>\n  </button>\n  <mat-paginator\n    *ngIf=\"viewOptions.showPaginator\"\n    [pageSizeOptions]=\"[5, 25, 50]\"\n    [length]=\"resultsLength\"\n    [pageSize]=\"5\"\n    showFirstLastButtons>\n  </mat-paginator>\n</div>\n<table mat-table [dataSource]=\"dataSource\" matSort class=\"mat-elevation-z8\">\n  <ng-container *ngFor=\"let collumn of displayedColumns\">\n    <ng-container\n      *ngIf=\"\n        collumn.collumnName !== 'select' &&\n        collumn.collumnName !== 'actions' &&\n        displayedColumns\"\n      [matColumnDef]=\"collumn.collumnName\"\n      >\n      <th\n        mat-header-cell\n        *matHeaderCellDef\n        mat-sort-header\n        [ngStyle]=\"{\n          'width.%': collumn.widthInPercentage\n            ? collumn.widthInPercentage\n            : 'auto'\n        }\">\n        {{ collumn.collumnKey? (collumn.collumnKey | translate) : collumn.collumnName }}\n      </th>\n      <td mat-cell *matCellDef=\"let element\">\n        {{ element[collumn.collumnName] }}\n      </td>\n    </ng-container>\n  </ng-container>\n\n  <ng-container *ngIf=\"viewOptions.showCheckbox\" matColumnDef=\"select\">\n    <th mat-header-cell *matHeaderCellDef>\n      <mat-checkbox\n        (change)=\"$event ? masterToggle() : null\"\n        [checked]=\"selection.hasValue() && isAllSelected()\"\n        [indeterminate]=\"selection.hasValue() && !isAllSelected()\">\n      </mat-checkbox>\n    </th>\n    <td mat-cell *matCellDef=\"let row\">\n      <mat-checkbox\n        (click)=\"$event.stopPropagation()\"\n        (change)=\"$event ? selection.toggle(row) : null\"\n        [checked]=\"selection.isSelected(row)\">\n      </mat-checkbox>\n    </td>\n  </ng-container>\n\n  <ng-container *ngIf=\"viewOptions.showActions\" matColumnDef=\"actions\">\n    <th mat-header-cell *matHeaderCellDef></th>\n    <td mat-cell *matCellDef=\"let row\" (click)=\"$event.stopPropagation()\">\n      <button\n        mat-icon-button\n        (click)=\"onDeleteRecord(row)\"\n        style=\"float: right;\">\n        <mat-icon>delete_forever</mat-icon>\n      </button>\n      <button\n        *ngIf=\"viewOptions.type !== 'FILE'\"\n        mat-icon-button\n        (click)=\"onEdit(row)\"\n        style=\"float: right;\">\n        <mat-icon>edit</mat-icon>\n      </button>\n      <button\n        *ngIf=\"viewOptions.type === 'FILE'\"\n        mat-icon-button\n        (click)=\"onDownload(row)\"\n        style=\"float: right;\">\n        <mat-icon>get_app</mat-icon>\n      </button>\n    </td>\n  </ng-container>\n\n  <tr\n    mat-header-row\n    *matHeaderRowDef=\"collumnsToBeDisplayed; sticky: true\"></tr>\n  <tr\n    mat-row\n    *matRowDef=\"let row; columns: collumnsToBeDisplayed\"\n    (click)=\"selection.toggle(row)\"></tr>\n</table>\n\n<div class=\"flex flex-end table-action\" *ngIf=\"viewOptions.showCheckbox\">\n  <button\n    style=\"width: 165px; margin-right: 20px; white-space: normal; line-height: normal;\"\n    *ngIf=\"viewOptions.type === 'FILE'\"\n    mat-raised-button\n    color=\"primary\">\n    File Upload\n  </button>\n\n  <!--Delete All Selected-->\n  <button\n    *ngIf=\"viewOptions.showCheckbox && viewOptions.showDeleteAllButton\"\n    style=\"width: 165px;\"\n    mat-raised-button\n    color=\"primary\"\n    [disabled]=\"selection.isEmpty()\"\n    (click)=\"onDeleteSelectedRecords()\">\n    L\u00F6schen\n  </button>\n</div>\n",
                styles: ["table{width:100%}.row{display:flex;flex-direction:row-reverse;margin-bottom:5px}.long-filter{float:left;width:calc(100% - 520px)!important}.short-filter{float:left;width:calc(100% - 560px)!important}#table-export{float:right;margin-top:8px}.mat-column-actions{width:104px!important;white-space:unset!important}.mat-column-select{width:50px!important}\n"]
            },] }
];
TableComponent.ctorParameters = () => [
    { type: MatDialog },
    { type: TranslatePipe }
];
TableComponent.propDecorators = {
    dataSource: [{ type: Output }],
    displayedColumns: [{ type: Input }],
    viewOptions: [{ type: Input }],
    data: [{ type: Input }],
    paginator: [{ type: ViewChild, args: [MatPaginator,] }],
    sort: [{ type: ViewChild, args: [MatSort,] }],
    edit: [{ type: Output }],
    download: [{ type: Output }],
    delete: [{ type: Output }],
    deleteBulk: [{ type: Output }]
};

class SlideToggleComponent extends BaseFieldComponent {
    constructor(fb, fs, ts) {
        super(fb, fs, ts);
        this.fb = fb;
        this.fs = fs;
        this.ts = ts;
    }
    ngOnInit() {
        super.ngOnInit();
        // console.log(this.options);
        // console.log(this.form);
    }
}
SlideToggleComponent.decorators = [
    { type: Component, args: [{
                selector: 'app-slidetoggle',
                template: "<ng-container *ngIf=\"form\" [formGroup]=\"form\">\n  <mat-form-field [hintLabel]=\"name+'#hintlabel' | translate\">\n    <mat-slide-toggle\n          class=\"example-margin\"\n          [color]=\"color\"\n          [formControlName]=\"name\"\n          [checked]=\"value\"\n          [matTooltip]=\"getName() + '#tooltip' | translate\"\n          matTooltipDisabled=\"false\"\n          matTooltipHideDelay=\"200\"\n          matTooltipPosition=\"above\"\n          matTooltipShowDelay=\"100\">\n        {{ getName() + \"#label\" | translate }}\n      </mat-slide-toggle>\n      <mat-hint *ngIf=\"hint\" align=\"end\">{{hint}}</mat-hint>\n      <mat-error>\n        {{ getErrorMeesage() }}\n      </mat-error>\n  </mat-form-field>\n</ng-container>\n",
                styles: [""]
            },] }
];
SlideToggleComponent.ctorParameters = () => [
    { type: FormBuilder },
    { type: FormService },
    { type: TranslationService }
];
SlideToggleComponent.propDecorators = {
    color: [{ type: Input }]
};

registerLocaleData(localeDe, 'de');
const ɵ0 = MAT_MOMENT_DATE_FORMATS;
class FormbuilderModule {
    static forRoot() {
        return {
            ngModule: FormbuilderModule,
            providers: [
                TranslationService,
                ConfigService,
                DataFlattnerService,
                TranslatePipe
            ]
        };
    }
}
FormbuilderModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    FormbuilderComponent,
                    BaseFieldComponent,
                    SelectComponent,
                    TextInputComponent,
                    DateInputComponent,
                    FileInputComponent,
                    AutocompleteComponent,
                    CheckboxComponent,
                    RadiobuttonComponent,
                    SliderComponent,
                    TranslatePipe,
                    ConfirmDialogComponent,
                    ErrorDialogSimpleComponent,
                    InfoDialogSimpleComponent,
                    TableComponent,
                    SlideToggleComponent
                ],
                imports: [
                    BrowserModule,
                    CommonModule,
                    HttpClientModule,
                    MatIconModule,
                    ReactiveFormsModule,
                    MatFormFieldModule,
                    MatInputModule,
                    MatListModule,
                    MatGridListModule,
                    MatCardModule,
                    MatSelectModule,
                    MatAutocompleteModule,
                    MatDatepickerModule,
                    MatMomentDateModule,
                    BrowserAnimationsModule,
                    MatCheckboxModule,
                    MatStepperModule,
                    MatTooltipModule,
                    MatTreeModule,
                    MatButtonModule,
                    MatSidenavModule,
                    MatExpansionModule,
                    MatRadioModule,
                    MatDialogModule,
                    MatTableModule,
                    MatSortModule,
                    MatPaginatorModule,
                    MatSliderModule,
                    MatSlideToggleModule
                ],
                providers: [
                    { provide: MAT_DATE_LOCALE, useValue: 'de' },
                    { provide: DateAdapter, useClass: MomentDateAdapter, deps: [MAT_DATE_LOCALE] },
                    { provide: MAT_DATE_FORMATS, useValue: ɵ0 },
                    TranslatePipe
                ],
                bootstrap: [FormbuilderComponent],
                exports: [
                    FormbuilderComponent,
                    SelectComponent,
                    TextInputComponent,
                    DateInputComponent,
                    FileInputComponent,
                    AutocompleteComponent,
                    CheckboxComponent,
                    RadiobuttonComponent,
                    SliderComponent,
                    TableComponent,
                    SlideToggleComponent,
                    TranslatePipe
                ]
            },] }
];

class DataConnectorService {
    constructor(http) {
        this.http = http;
        this.url = 'api';
    }
    create(post, itemType) {
        return this.http.post('/api/' + itemType, { ['item']: post }, { headers: { 'Content-Type': 'application/json' } });
    }
    update(id, post, itemType) {
        if (post) {
            return this.http.put('/api/' + itemType, { ['item']: post }, { headers: { 'Content-Type': 'application/json' } });
        }
        return 'incoorect input';
    }
    get(itemType, id = "0", kat = [], txt = '') {
        let res;
        res = [];
        let search = {};
        if (id !== '0') {
            search.id = id;
        }
        if (kat && kat.length > 0) {
            search.categories = kat;
        }
        if (txt !== '') {
            search.text = txt;
        }
        let options = {
            headers: new HttpHeaders({ 'Content-Type': 'application/json' }),
            params: search
        };
        return this.http.get('/api/' + itemType, options);
    }
    delete(id, itemType) {
        if (id) {
            return this.http.delete('/api/' + itemType, {
                headers: { 'Content-Type': 'application/json' },
                params: { id: id }
            });
        }
        return 'no id';
    }
    getFields() {
        return this.http.get(this.url + '/get');
    }
    insertField(field) {
        return this.http.post(this.url + '/insert', field);
    }
    deleteField(id) {
        return this.http.delete(this.url + '/delete', id);
    }
    getAsyncValidation(url, body) {
        return this.http.post(url, body).pipe(map(value => {
            if (value) {
                return value;
            }
            else {
                return timer(2000).pipe(map(() => {
                    return { 'error': true };
                }));
            }
        }));
    }
}
DataConnectorService.ɵprov = i0.ɵɵdefineInjectable({ factory: function DataConnectorService_Factory() { return new DataConnectorService(i0.ɵɵinject(i1$1.HttpClient)); }, token: DataConnectorService, providedIn: "root" });
DataConnectorService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
DataConnectorService.ctorParameters = () => [
    { type: HttpClient }
];

class DataStoreService {
    constructor() {
        this.navbarVisibility = new BehaviorSubject(true);
        this.currentUser = new ReplaySubject(1);
        this.allowedActions = new ReplaySubject(1);
    }
    showNavbar(shouldNavbarBeVisible) {
        this.navbarVisibility.next(shouldNavbarBeVisible);
    }
    getNavbarState() {
        return this.navbarVisibility;
    }
    getCurrentUser() {
        return this.currentUser;
    }
    setCurrentUser(value) {
        this.currentUser.next(value);
    }
    getAllowedActions() {
        return this.allowedActions;
    }
    setAllowedActions(value) {
        this.allowedActions.next(value);
    }
}
DataStoreService.ɵprov = i0.ɵɵdefineInjectable({ factory: function DataStoreService_Factory() { return new DataStoreService(); }, token: DataStoreService, providedIn: "root" });
DataStoreService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
DataStoreService.ctorParameters = () => [];

class UserService {
    constructor(http, dialogService) {
        this.http = http;
        this.dialogService = dialogService;
        this.headers = new HttpHeaders()
            .set('Content-Type', 'application/json')
            .set('Charset', 'UTF-8');
        this.options = { headers: this.headers };
        this.apiBaseUrl = '/api';
    }
    login(credentials, url) {
        const headers = new HttpHeaders()
            .set('Content-Type', 'application/json')
            .set('Charset', 'UTF-8')
            .set('Authorization', 'Basic ' + btoa(credentials));
        const options = {
            headers: headers,
            observe: 'response',
            withCredentials: true
        };
        return this.http.post(url, null, options);
    }
    logout(url) {
        this.options = { headers: this.headers };
        return this.http.delete(url, this.options);
    }
    /**
     * Gets current users profile.
     */
    getUserProfile(url) {
        // const headers = this.headers.set('useMockup', 'true');
        // const options = {headers: headers};
        // return this.http.get(this.apiBaseUrl + `user/profile`, options);
        return this.http.get(url, this.options);
    }
    /**
     * Get the allowed actions of the current user
     */
    getUserRoles(url) {
        // const headers = this.headers.set('useMockup', 'true');
        // const options = {headers: headers};
        // return this.http.get(this.apiBaseUrl + `user/role`, options)
        //   .pipe(
        //     map(value => value['actions'])
        //   );
        return this.http.get(url, this.options);
    }
    /**
     * get all users
     */
    getUsers(url) {
        // const headers = this.headers.set('useMockup', 'true');
        // const options = {headers: headers};
        return this.http.get(url, this.options);
    }
    getUser(url, userId) {
        return this.http.get(`${url}${userId}`, this.options);
    }
    addUser(url, user) {
        return this.http.post(url, JSON.stringify(user), this.options);
    }
    addUserAndRoles(url, user) {
        // check if bkuUser already exists
        const done = new ReplaySubject(1);
        this.addUser(url, user).subscribe(addUserRes => {
            user.id = addUserRes.id;
            this.updateRoles(url, user).subscribe(updateRoleResp => done.next(updateRoleResp));
        }, error => {
            this.dialogService.showErrorDialog('Error');
        });
        return done;
    }
    editUser(url, user) {
        return this.http.put(`${url}${user.id}`, JSON.stringify(user), this.options);
    }
    editUserAndRoles(url, user) {
        return forkJoin(this.editUser(url, user), this.updateRoles(url, user));
    }
    deleteUser(url, user) {
        return this.http.delete(`${url}${user.id}`, this.options);
    }
    updateRoles(url, user) {
        const rolesObject = {
            'roles': user.roles
        };
        return this.http.put(`${url}${user.id}`, JSON.stringify(rolesObject), this.options);
    }
}
UserService.ɵprov = i0.ɵɵdefineInjectable({ factory: function UserService_Factory() { return new UserService(i0.ɵɵinject(i1$1.HttpClient), i0.ɵɵinject(DialogService)); }, token: UserService, providedIn: "root" });
UserService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
UserService.ctorParameters = () => [
    { type: HttpClient },
    { type: DialogService }
];

class AuthenticationService {
    constructor(router, userService, dataStore) {
        this.router = router;
        this.userService = userService;
        this.dataStore = dataStore;
        this._isLoggedIn = false;
        this.bla = 'fbapp-user';
        this.registerCurrentUser();
        this.registerAllowedActions();
        const storedUserProfile = this.loadUserProfile();
        //const storedAllowedActions = this.loadAllowedActions();
        if (!!storedUserProfile) {
            this.dataStore.setCurrentUser(storedUserProfile);
        }
        /*
            if (!!storedAllowedActions) {
              this.dataStore.setAllowedActions(storedAllowedActions);
            }
        */
    }
    /*
      hasAvailableAction(systemResource: SystemResource, systemAction: SystemAction) {
        if (systemResource && systemAction && this.allowedActions && systemResource in this.allowedActions) {
          const roles: Object = this.allowedActions[systemResource];
          const allActionsWithDuplicates = Object.values(roles)
            .reduce((previousValue, currentValue) => {
              return previousValue.concat(currentValue);
            });
          const availableActions = Array.from(new Set(allActionsWithDuplicates)); // [C, C, R, R, U] => [C, R, U]
          if (!!availableActions && availableActions.indexOf(systemAction) >= 0) {
            return true;
          }
        }
        return false;
      }
    
      hasRole(systemRole: SystemRole) {
        if (!systemRole || !this.currentUser) {
          return false;
        }
    
        const currentUserRoles: string[] = this.currentUser.roles;
        if (currentUserRoles.indexOf(systemRole) >= 0) {
          return true;
        }
        return false;
      }
    */
    login(loginurl, username, password) {
        const usernameAndPassword = username + ':' + password;
        return this.userService.login(usernameAndPassword, loginurl).pipe(tap(resp => {
            // console.log('[authenticationService] - login successful', resp);
            this.isLoggedIn = true;
        }), tap(() => {
            // this.getUserProfile();
        }), tap(() => {
            // this.getUserActions();
        }));
    }
    getUserProfile(url) {
        this.userService.getUserProfile(url).subscribe((profile) => {
            // console.log('[AuthenticationService] - getUserProfile', profile);
            this.dataStore.setCurrentUser(profile);
        }, (errObj) => {
            throwError(errObj);
        });
    }
    /*
      getUserActions() {
        this.userService.getUserRoles().subscribe((actionResp: Object) => {
          if (actionResp.hasOwnProperty('actions')) {
            // console.log('[AuthenticationService] - getUserActions', actionResp);
            this.dataStore.setAllowedActions(actionResp['actions']);
          } else {
            this.dataStore.setAllowedActions(null);
          }
        }, (errObj) => {
          throwError(errObj);
        });
      }
    */
    logout(navigateToLoginpage = true, url) {
        this.isLoggedIn = false;
        this.dataStore.setCurrentUser(null);
        // this.dataStore.setAllowedActions(null);
        this.userService.logout(url).subscribe(null, null, () => {
            if (navigateToLoginpage) {
                this.navigateToLoginPage();
            }
        });
    }
    /**
     * Removes Authentication Informations from Localstorage
     * and navigates to the loginpage.
     */
    handleSessionTimeout() {
        this.isLoggedIn = false;
        this.dataStore.setCurrentUser(null);
        //this.dataStore.setAllowedActions(null);
        this.navigateToLoginPage();
    }
    /**
     * Checks currently only if the userProfile is stored locally
     * FIXME: An additional test for a valid cookie would be more useful.
     */
    checkIfUserIsAlreadyLoggedIn() {
        const storedUserProfile = this.loadUserProfile();
        const storedAllowedActions = true; //his.loadAllowedActions();
        if (!!storedUserProfile && !!storedAllowedActions) {
            this.isLoggedIn = true;
            this.dataStore.setCurrentUser(storedUserProfile);
            // this.dataStore.setAllowedActions(storedAllowedActions);
            return true;
        }
        this.isLoggedIn = false;
        this.dataStore.setCurrentUser(null);
        //this.dataStore.setAllowedActions(null);
        return false;
    }
    navigateToLoginPage() {
        this.router.navigate(['login']);
    }
    loadUserProfile() {
        let res = localStorage.getItem(this.bla);
        return JSON.parse(res != null ? res : '');
    }
    saveUserProfile(userProfile) {
        // console.log('saveUserProfile', userProfile);
        if (!!userProfile) {
            localStorage.setItem(this.bla, JSON.stringify(userProfile));
        }
        else {
            localStorage.removeItem(this.bla);
        }
    }
    /*
      loadAllowedActions(): any {
        return JSON.parse(localStorage.getItem(this.USER_ALLOWED_ACTIONS));
      }
    
      saveAllowedActions(actions: any): void {
        // console.log('saveAllowedActions', actions);
        if (!!actions && Object.keys(actions).length > 0) {
          localStorage.setItem(this.USER_ALLOWED_ACTIONS, JSON.stringify(actions));
        } else {
          localStorage.removeItem(this.USER_ALLOWED_ACTIONS);
        }
      }
    */
    get isLoggedIn() {
        return this._isLoggedIn;
    }
    set isLoggedIn(value) {
        this._isLoggedIn = value;
    }
    registerCurrentUser() {
        this.dataStore.getCurrentUser().subscribe((user) => {
            this.currentUser = user;
            this.saveUserProfile(user);
        });
    }
    registerAllowedActions() {
        this.dataStore.getAllowedActions().subscribe((actions) => {
            this.allowedActions = actions;
            //this.saveAllowedActions(actions);
        });
    }
}
AuthenticationService.ɵprov = i0.ɵɵdefineInjectable({ factory: function AuthenticationService_Factory() { return new AuthenticationService(i0.ɵɵinject(i1$3.Router), i0.ɵɵinject(UserService), i0.ɵɵinject(DataStoreService)); }, token: AuthenticationService, providedIn: "root" });
AuthenticationService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
AuthenticationService.ctorParameters = () => [
    { type: Router },
    { type: UserService },
    { type: DataStoreService }
];

/*
 * Public API Surface of formbuilder
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AuthenticationService, AutocompleteComponent, BaseFieldComponent, CheckboxComponent, ConfigService, DataConnectorService, DataFlattnerService, DateInputComponent, DialogService, FileInputComponent, FormService, FormbuilderComponent, FormbuilderModule, FormbuilderService, RadiobuttonComponent, SelectComponent, SlideToggleComponent, SliderComponent, TableComponent, TableType, TextInputComponent, TranslatePipe, TranslationService, UserService, _filter, checkKey, ɵ0, ConfirmDialogComponent as ɵa, ErrorDialogSimpleComponent as ɵb, InfoDialogSimpleComponent as ɵc, DataStoreService as ɵd };
//# sourceMappingURL=formbuilder.js.map
