import { IField, IHTMLAttributes } from '../interfaces/ifield';
import { ICustomValidation } from '../interfaces/icustom-validation';
import { IValidator } from '../interfaces/ivalidator';
import { EventEmitter, OnInit } from '@angular/core';
import { FormBuilder, FormControl, FormGroup } from '@angular/forms';
import { FormService } from '../services/form.service';
import { TranslationService } from '../services/translation.service';
export declare class BaseFieldComponent implements IField, OnInit {
    fb: FormBuilder;
    fs: FormService;
    ts: TranslationService;
    private readonly MSGerrors;
    name: string;
    value: string;
    placeholder: string;
    disabled: boolean;
    minLength: number;
    maxLength: number;
    min: number;
    max: number;
    required: boolean;
    form: FormGroup;
    control: FormControl;
    hintlabel: string;
    hint: string;
    tooltip: string;
    htmlType: string;
    iconBtn: string;
    iconAction: EventEmitter<any>;
    validators: IValidator;
    customValidation: ICustomValidation[];
    htmlAttribute: IHTMLAttributes;
    autocomplete: string;
    change: EventEmitter<any>;
    init: boolean;
    field: IField;
    constructor(fb: FormBuilder, fs: FormService, ts: TranslationService);
    get(): BaseFieldComponent;
    getErrorMeesage(): any;
    getMeesage(type: string, param: any): any;
    ngOnInit(): void;
    setUpConfig(config: IField): void;
    getValue(): any;
    getName(): string;
    synchronizeValidator(): void;
    getValidators(): IValidator;
    getFieldConfig(): IField;
    iconAct(): void;
}
